with GNAT.String_Split;

use GNAT;

package body Util_Text is

   procedure Split_Action (
      Action : in String;
      Caller : out Input_Types.Caller;
      Request : out Input_Types.GUI_Request)
   is
     Subs : String_Split.Slice_Set;
     Seps : constant String := ".";
      begin
         String_Split.Create (S          => Subs,
                              From       => Action,
                              Separators => Seps,
                              Mode       => String_Split.Multiple);
        declare
          Pre  : constant String := String_Split.Slice (Subs, 1);
          Post : constant String := String_Split.Slice (Subs, 2);
      begin
           Caller  :=  Input_Types.Caller'value(Pre);
           Request := Input_Types.GUI_Request'value(Post);
      end;
  end Split_Action;

   protected body Connections_Counter is

      function Get return Natural is
      begin
         return Connections_Count;
      end Get;

      procedure Increment is
      begin
            Connections_Count := Connections_Count + 1;
      end Increment;

      procedure Increment_Limited(Success : out Boolean) is
      begin
         if is_Cero then
            Connections_Count := Connections_Count + 1;
            Success := True;
         else
            Success := False;
         end if;
      end Increment_Limited;


      procedure Decrement is
      begin
         if not Is_Cero then
            Connections_Count := Connections_Count - 1;
         end if;
      end Decrement;


      function Is_Cero return Boolean is
      begin
         return Connections_Count = 0;
      end Is_Cero;

   end Connections_Counter;

end Util_Text;
