with Input_Types;
Package Util_Text is

    procedure Split_Action (
      Action : in String;
      Caller : out Input_Types.Caller;
      Request : out Input_Types.GUI_Request);
  --  <summary>This procedure transform a String "Action" and returns two 
  --      enumeration values Caller and Request</summary>
   --  <parameter name="Action">String Action</parameter>
   --  <parameter name="Caller">GUI type caller</parameter>
   --  <parameter name="Request">GUI Request type</parameter>end Util_Text;

   protected type Connections_Counter is
      function Get return Natural;
  --  <summary>Get the number of connections </summary>
      procedure Increment;
  --  <summary>increment Number of alive connections, with no limit</summary>
  --  <parameter name="Success">addition success </parameter>

      procedure Increment_Limited(Success : out Boolean);
  --  <summary>increment the Number of alive connections, the limit is 1 </summary>
  --  <parameter name="Success">addition success </parameter>
      procedure Decrement;
  --  <summary>decrement the Number of alive connections </summary>
  --  <parameter name="Success">addition success </parameter>

   private
      function Is_Cero return Boolean;
  --  <summary>Get True if exist an available connection </summary>
      Connections_Count     : Natural := 0;

   end Connections_Counter;
  --  <summary>This protect type helps Controller to Manage all the simultaneous
  --    connect requests GUI's </summary>
  --  <parameter name="Connections_Counter">Represent the number of alive 
  --  connections

end Util_Text;
