with Ada.Text_IO;    use Ada.Text_IO;
with Billboard_Television; use Billboard_Television;
with PolyORB.Parameters;
with Output_Types;
with Billboard_Output; use  Billboard_Output;
with Ada.Exceptions;
with Simulation_Exceptions;
with Load_Configuration; use Load_Configuration;
-- billboard main procedure
procedure Billboard_Output_Main is
   -- two task to publish television frame to medium and low quality SpectatorGUI
   MQ_Television_Manager : Television_Manager_Task(Output_Types.MQ);
   LQ_Television_Manager : Television_Manager_Task(Output_Types.LQ);
begin
   Load_Configuration.Read_Configuration;
   Billboard_Output.Initialize_Publishers;
   -- this procedure initialize all Publishers
   MQ_Television_Manager.Start;
   LQ_Television_Manager.Start;

exception -- Start of exception handlers
  when Simulation_Exceptions.Configuration_Error =>
    Ada.Text_IO.Put("Problems with config/DISTRIBUTION.txt content");

  when Error : others => 
    -- Handle all others
    Ada.Text_IO.Put("Exception: ");
    Ada.Text_IO.Put_Line(Ada.Exceptions.Exception_Name(Error));
    Ada.Text_IO.Put_Line(Ada.Exceptions.Exception_Message(Error));
end Billboard_Output_Main;

