with Ada.Text_IO; use Ada.Text_IO;
with Billboard_Output;
package body Billboard_Television is

   task body Television_Manager_Task is
      Period : Duration;
   begin
      -- init the television period depending on the television type
      case Television_Type is
         when Output_Types.MQ =>
            -- period is 60 milliseconds for medium quality SpectatorGUI
            Period := 0.7;
         when Output_Types.LQ =>
            -- period is 90 milliseconds for low quality SpectatorGUI
            Period := 1.3;
      end case;
      -- wait for Billboard_Output initialization
      accept Start;
      -- start television loop
      loop
         case Television_Type is
            when Output_Types.MQ =>
               -- publish television frame using medium quality publisher
               Billboard_Output.Notify_MQ_Television_Frame;
            when Output_Types.LQ =>
               -- publish television frame using low quality publisher
               Billboard_Output.Notify_LQ_Television_Frame;
         end case;
         -- wait the next period
         delay Period;
      end loop;
   end Television_Manager_Task;

end Billboard_Television;
