package Input_Types is
   pragma Remote_Types;

   type GUI_Request is(
      connect,
      disconnect,
      startMatch,
      stopMatch,
      startSecondHalf,
      saveTeamConfig,
      tacticChange,
      playerSubstitution);
   --  parameter name="connect">connect</parameter>
   --  parameter name="disconnect">disconnect</parameter>
   --  parameter name="startMatch">startMatch</parameter>
   --  parameter name="stopMatch">stopMatch</parameter>
   --  parameter name="startSecondHalf">startSecondHalf</parameter>
   --  parameter name="saveTeamConfig">saveTeamConfig</parameter>
   --  parameter name="tacticChange">tacticChange</parameter>
   --  parameter name="playerSubstitution">playerSubstitution</parameter>

     subtype SimulatorGUI_Request is 
        GUI_Request range connect .. startSecondHalf;
     subtype ManagerGUI_Request is 
        GUI_Request range saveTeamConfig .. playerSubstitution;
--          GUI_Request range connect .. disconnect, saveTeamConfig .. playerSubstitution ;

     subtype SpectatorGUI_Request is 
        GUI_Request range connect .. disconnect;

   type Core_Notification is (
      --shared requests
      matchStarted,
      matchFinished,
      firstHalfTimeFinished,
      secondHalfTimeFinished,
      writeTextArea,  
      matchAborted);
   --  parameter name="matchStarted">matchStarted</parameter>
   --  parameter name="matchFinished">matchFinished</parameter>
   --  parameter name="firstHalfTimeFinished">firstHalfTimeFinished</parameter>
   --  parameter name="secondHalfTimeFinished">secondHalfTimeFinished</parameter>
   --  parameter name="writeTextArea">writeTextArea</parameter>
   --  parameter name="matchAborted">matchAborted</parameter>


   type Caller is (
      simulatorGUI,
      localManagerGUI,
      visitorManagerGUI,
      spectatorGUI);
   --  parameter name="simulatorGUI">simulatorGUI</parameter>
   --  parameter name="localManagerGUI">localManagerGUI</parameter>
   --  parameter name="visitorManagerGUI">visitorManagerGUI</parameter>
   --  parameter name="spectatorGUI">spectatorGUI</parameter>
     subtype ManagerGUI is 
        Caller range localManagerGUI .. visitorManagerGUI;

end Input_Types;

