with Ada.Text_IO; use Ada.Text_IO;
with Ada.Strings.Unbounded; use Ada.Strings.Unbounded;
with Simulation_Exceptions; use Simulation_Exceptions; 

package body Load_Configuration is

  function Get_Billboard_Input_Host return Unbounded_String is
    begin
      Put_Line("Billboard_Input_Host="
                &Ada.Strings.Unbounded.To_String(Billboard_Input_Host));
      return Billboard_Input_Host;
    end Get_Billboard_Input_Host;

    function Get_Billboard_Output_Host return Unbounded_String is
    begin
      Put_Line("Billboard_Output_Host="
                &Ada.Strings.Unbounded.To_String(Billboard_Output_Host));
      return Billboard_Output_Host;
    end Get_Billboard_Output_Host;

  procedure Read_Configuration is
     Hosts	: Ada.Text_IO.File_Type;
     File_Name	: constant String := "config/DISTRIBUTION.txt";
     Line	: Unbounded_String;
  begin
     Open(File => Hosts,
          Mode => In_File,
          Name => File_Name);
     -- Reading file and parsing configuration
     -- (dirty, but works. Shouldn't we use AdaXML instead?)
     while not End_Of_File(Hosts) loop
        Line := To_Unbounded_String(Get_Line(Hosts));
        if Ada.Strings.Unbounded.Count(Line, "=") = 1 then
           if Slice(Line, 1, Index(Line, "=") - 1) = "BILLBOARD_INPUT" then
              Billboard_Input_Host := To_Unbounded_String
                (Slice(Line, Index(Line, "=") + 1,
                 Ada.Strings.Unbounded.Length(Line)));
           elsif Slice(Line, 1, Index(Line, "=") - 1) = "BILLBOARD_OUTPUT" then
              Billboard_Output_Host := To_Unbounded_String
                (Slice(Line, Index(Line, "=") + 1,
                 Ada.Strings.Unbounded.Length(Line)));
           elsif Slice(Line, 1, Index(Line, "=") - 1) = "CORE" then
              Core_Host := To_Unbounded_String
                (Slice(Line, Index(Line, "=") + 1,
                 Ada.Strings.Unbounded.Length(Line)));
           else
              New_Line;
              Put_Line("ERROR: FOUND AN INVALID KEY. Please verify" &File_Name);
              New_Line;
           end if;
        end if;
     end loop;

     Close(Hosts);

     -- Printing the configuration
     
     if Billboard_Input_Host = Null_Unbounded_String then
        Put_Line("Billboard_Input_Host not found in "& File_Name);
        raise Configuration_Error with "Billboard_Input_Host not found in "
               & File_Name;
     end if;
     if Billboard_Output_Host = Null_Unbounded_String then
        Put_Line("Billboard_Output_Host not found in "& File_Name);
        raise Configuration_Error with "Billboard_Output_Host not found in "
            & File_Name;
     end if;
     if Core_Host = Null_Unbounded_String then
        Put_Line("Core_Host not found in "& File_Name);
        raise Configuration_Error with "Billboard_Output_Host not found in "
            & File_Name;
     end if;

  end Read_Configuration;


end Load_Configuration;
