package body Game_Control is

   protected body Game_State is

      function Get return State_Record_T is
      begin
         return State_Record;
      end Get;

      procedure Set(New_State : in State_Record_T) is
      begin
         State_Record := New_State;
      end Set;

      procedure End_Match is
      begin
         State_Record.State := End_Match;
         State_Record.Status := Second_Half_Finished;
      end End_Match;

      procedure Abort_Match is
      begin
         State_Record.State := End_Match;
         State_Record.Status := Match_Aborted;
      end Abort_Match;

      entry Wait_For_Restart when State_Record.State = Play is
      begin
         null;
      end Wait_For_Restart;

      entry Wait_For_Positioning
        when State_Record.State = Kick_Off or State_Record.State = End_Match
      is
      begin
         null;
      end Wait_For_Positioning;

      entry Wait_For_Players when Wait_For_Restart'Count = Players_Number is
      begin
         null;
      end Wait_For_Players;

      entry Enable_Start_2nd_Time_Request
        when Wait_For_Positioning'Count = Players_Number
      is
      begin
         null;
      end Enable_Start_2nd_Time_Request;

      entry Wait_The_End when Players_Number = 0 is
      begin
         null;
      end Wait_The_End;

      procedure Increase_Players_Number is
      begin
         Players_Number := Players_Number + 1;
      end;

      procedure Decrease_Players_Number is
      begin
         Players_Number := Players_Number - 1;
      end;

      procedure Half_Time_Break is
      begin
         State_Record.State := Half_Time_Break;
         State_Record.Status := First_Half_Finished;
      end Half_Time_Break;

      procedure Start is
      begin
         State_Record.State := Play;
      end Start;
   end Game_State;
end Game_Control;
