with Ada.Strings.Unbounded; use Ada.Strings.Unbounded;
with Utils;
with Status; use Status;
with Billboard_Output; use Billboard_Output;

package body Events.Ball_Out is
   procedure Process(Event : in Ball_Out_Event_T) is
      Message : Unbounded_String;
      Team_Name : constant Unbounded_String := Teams_Status(Event.Which_Goal).Get_Name;
   begin
      -- create the message
      case Event.Category is
         when Goal_Line =>
            Message := To_Unbounded_String("Ball crosses the goal line.");
         when Goal =>
            Message := "Ball crosses "
              & Team_Name & "'s goal line.";
         when Touch_Line =>
            Message := To_Unbounded_String("Ball is out of pitch.");
      end case;
      -- print the message
      Utils.Logger.Add_Log(To_String(Message));
      -- send message (to SpectatorGUIs)
      Send_Message(To_String(Message), Output_Types.Spectator);
   end Process;
end Events.Ball_Out;
