with Ada.Strings.Unbounded; use Ada.Strings.Unbounded;
with Status; use Status;
with Utils;
with Tactic; use Tactic;
with Billboard_Output; use Billboard_Output;

package body Events.Change_Tactic is
   procedure Process(Event : in Change_Tactic_Event_T) is
      Message : Unbounded_String;
      Team_Name : constant Unbounded_String :=
        Teams_Status(Event.Team_Id).Get_Name;
   begin
      -- create and send the message
      Message := Team_Name & " changes its tactic; new formation is "
        & Tactic.Formations_Array(Event.Formation_Id).Name & " and new pressing value is "
        & Event.Pressing_Value'Img & ".";
      -- print the message
      Utils.Logger.Add_Log(To_String(Message));
      -- send message (to player team MagagerGUI)
      case Event.Team_Id is
         when Local =>
            Send_Message(To_String(Message), Output_Types.Local_Manager);
         when Visitor =>
            Send_Message(To_String(Message), Output_Types.Visitor_Manager);
      end case;
   end Process;
end Events.Change_Tactic;
