with Player; use Player;

package Events.Goal is
   -- a subtype of Event_T to implement the goal event type
   type Goal_Event_T is new Event_T with record
      -- the team which gained the goal
      Team_Id : Team_Id_T;
      -- the player which made the goal (no autogoal)
      Player_Id : Identifier_T;
      -- a boolean to say if the goal is an autogoal
      Is_Autogoal : Boolean;
   end record;

   -- overriding primitive operation Process to process a goal event
   procedure Process(Event : in Goal_Event_T);
end Events.Goal;
