with Ada.Strings.Unbounded; use Ada.Strings.Unbounded;
with Status; use Status;
with Utils;
with Billboard_Output; use Billboard_Output;

package body Events.Injury is
   procedure Process(Event : in Injury_Event_T) is
      Message : Unbounded_String;
      Player_Name : constant Unbounded_String :=
        Players_Characteristics(Event.Player_Id.Team_Id,
                                Event.Player_Id.Player_Number).Name;
      Team_Name : constant Unbounded_String :=
        Teams_Status(Event.Player_Id.Team_Id).Get_Name;
   begin
      -- create the log message
      Message := Player_Name & " (" & Team_Name & ","
        & Players_Characteristics(Event.Player_Id.Team_Id,
                                  Event.Player_Id.Player_Number).Shirt_Number'Img
        & ") is injured as a result of a foul.";
      -- update the player status in player statistics
      Statistics.Players_Statistics(Event.Player_Id.Team_Id,
                                    Event.Player_Id.Player_Number)
        .Current_Status := Injured;
      -- print the message
      Utils.Logger.Add_Log(To_String(Message));
      -- send message (to SpectatorGUIs)
      Send_Message(To_String(Message), Output_Types.Spectator);
   end Process;
end Events.Injury;
