with Ada.Strings.Unbounded; use Ada.Strings.Unbounded;
with Utils;
with Billboard_Output; use Billboard_Output;

package body Events.Interruption is
   procedure Process(Event : in Interruption_Event_T) is
      Message : Unbounded_String;
   begin
      -- create the log message
      case Event.Category is
         when Goal =>
            Message := To_Unbounded_String("The referee stops the game to assign a goal.");
         when Ball_Out =>
            Message := To_Unbounded_String("The referee stops the game because the ball went out of the pitch.");
         when Foul =>
            Message := To_Unbounded_String("The referee stops the game after a foul.");
      end case;
      -- print the message
      Utils.Logger.Add_Log(To_String(Message));
      -- send message (to SpectatorGUIs)
      Send_Message(To_String(Message), Output_Types.Spectator);
   end Process;
end Events.Interruption;
