with Player; use Player;

package Events.Penalty_Card is
   -- the category of the penalty card
   type Category_T is (First_Yellow, Second_Yellow, Red);

   -- a subtype of Event_T to implement the penalty card event type
   type Penalty_Card_Event_T is new Event_T with record
      -- the identifier of the player which receive the card
      Player_Id : Identifier_T;
      -- the card category
      Category : Category_T;
   end record;

   -- overriding primitive operation Process to process a penalty card event
   procedure Process(Event : in Penalty_Card_Event_T);
end Events.Penalty_Card;
