with Player; use Player;

package Events.Substitution is
   -- a subtype of Event_T to implement the substitution event type
   type Substitution_Event_T is new Event_T with record
      -- the incoming player identifier
      Incoming_Player_Id : Identifier_T;
      -- the outgoing player identifier
      Outgoing_Player_Id : Identifier_T;
      -- a boolean to say if referee has agreed the substitution
      Agreed : Boolean;
   end record;

   -- overriding primitive operation Process to process a substitution event
   procedure Process(Event : in Substitution_Event_T);
end Events.Substitution;
