with Player; use Player;

package Events.Tackle is
   -- the category of the tackle event
   type Category_T is (Successful, Unsuccessful, Foul);

   -- a subtype of Event_T to implement the tackle event type
   type Tackle_Event_T is new Event_T with record
      -- the identifier of the offending player
      Offending_Player_Id : Identifier_T;
      -- the identifier of the offended player
      Offended_Player_Id : Identifier_T;
      -- tackle category: successful, unsuccessful, foul
      Category : Category_T;
   end record;

   -- overriding primitive operation Process to process a tackle event
   procedure Process(Event : in Tackle_Event_T);
end Events.Tackle;
