with Player; use Player;

package Events.Throw is
   -- an enum type to specify the category of a throw event
   type Category_T is (Shooting, Passing);

   -- an enum type to specify the mode of a throw event
   type Mode_T is (Kick, Throw_In, Heading);

   -- a subtype of Event_T to implement the throw event type
   type Throw_Event_T is new Event_T with record
      -- the player identifier who made the throw
      Player_Id : Identifier_T;
      -- throw type: shooting or passing
      Category : Category_T;
      -- throw mode: kick, throw in or heading
      Mode : Mode_T;
   end record;

   -- overriding primitive operation Process to process a throw event
   procedure Process(Event : in Throw_Event_T);
end Events.Throw;
