package Events.Time_Out is
   -- an abstract subtype of Event_T to give a root-type for time-out like events
   type Time_Out_Event_T is abstract new Event_T with record
      -- a boolean to say if the event corresponds to the referee whistle
      Is_Whistle : Boolean;
   end record;

   -- a subtype of Time_Out_Event_T to implement the first half time out event type
   type First_Half_Time_Out_Event_T is new Time_Out_Event_T with null record;
   -- overriding primitive operation Process to process a first half time out event
   procedure Process(Event : in First_Half_Time_Out_Event_T);

   -- a subtype of Time_Out_Event_T to implement the break time out event type
   type Break_Time_Out_Event_T is new Time_Out_Event_T with null record;
   -- overriding primitive operation Process to process a break time out event
   procedure Process(Event : in Break_Time_Out_Event_T);

   -- a subtype of Time_Out_Event_T to implement the second half time out event type
   type Second_Half_Time_Out_Event_T is new Time_Out_Event_T with null record;
   -- overriding primitive operation Process to process a second half time out event
   procedure Process(Event : in Second_Half_Time_Out_Event_T);
end Events.Time_Out;
