with Utils;
with Billboard_Output; use Billboard_Output;

package body Events is
   protected body Events_Buffer is
      procedure Add(New_Event : in Event_T'Class) is
      begin
         Events_Buffer.Append(New_Event);
      end Add;
      entry Wait_For_Event when not Events_Buffer.Is_Empty is
      begin
         null;
      end Wait_For_Event;
      function Get_First return Event_T'Class is
      begin
         return Events_Buffer.First_Element;
      end Get_First;
      procedure Delete_First is
      begin
         Events_Buffer.Delete_First;
      end Delete_First;
   end Events_Buffer;

   task body Events_Manager_Task is
      Statistics_Period : constant Duration := 1.0;
   begin
      -- wait the start signal
      accept Start;
      while not Has_To_Terminate loop
         select
            -- wait for an event in the buffer
            Events_Buffer.Wait_For_Event;
            -- here we have at least one event in the buffer, take the first
            -- and process it
            Process(Events_Buffer.Get_First);
            -- after processing, delete processed event from buffer
            Events_Buffer.Delete_First;
         or delay Statistics_Period;
            -- send all statistics to "distribution"
            Send_Statistics_Frame(Statistics);
         end select;
      end loop;
   end Events_Manager_Task;
end Events;
