with Motion; use Motion;
with Player;

package Ball is
   -- a record type to implement the ball status
   type Ball_Status_T is record
      -- motion info
      Motion : Motion_3d_T;
      -- player who has the ball possession or player who touch the ball last
      Possessor : Player.Identifier_T;
      -- a boolean to store if the ball is not owned
      Free : Boolean;
   end record;

   -- a function to get the current motion of the ball
   function Get_Motion (Status : in Ball_Status_T) return Motion_3d_T;

   -- a function to say if nobody is currently holding the ball
   function Is_Free (Status: in Ball_Status_T) return Boolean;

   -- a function to get the identifier of the player who has the ball possession
   -- or has touched the ball the last time
   function Get_Possessor (Status : in Ball_Status_T) return Player.Identifier_T;
end Ball;

