with Events.Throw;

package Status.Manager is
   -- a task to implement the status manager
   task Manager is
      -- an entry used by players to update their current position
      entry Move(Team_Id		: in Team_Id_T;
                 Task_Id	 	: in Player_Index_T;
                 New_Position 		: in Coordinates_T);
      -- an entry used by players when they make a tackle
      entry Tackle(Team_Id 		: in Team_Id_T;
                   Player_Task_Id	: in Player_Index_T;
                   Offended_Shirt	: in Player_Number_T;
                   Tackle_Damage 	: in Float;
                   Success		: Boolean);
      -- an entry used by players when they catch the ball
      entry Catch(Team_Id 	: in Team_Id_T;
                  Player_Task_Id: in Player_Index_T;
                  Success	: in Boolean);
      -- an entry used by players when they throw the ball
      entry Throw(Team_Id 	: in Team_Id_T;
                  Player_Task_Id: in Player_Index_T;
                  Motion	: in Motion_3d_T;
                  Category	: in Events.Throw.Category_T;
                  Mode		: in Events.Throw.Mode_T);
   end Manager;
end Status.Manager;
