package body Status is
   function Get_Corresponding_Quantum(Time_Value: in Ada.Real_Time.Time)
                                      return Ada.Real_Time.Time
   is
      Current : Ada.Real_Time.Time;
      TS: Time_Span;
      -- Number of periods passed since Start_Time
      Periods_Num: Integer;
   begin
      TS := Time_Value - Status.Start_Time;
      Periods_Num := TS / Status.Quantum;
      Current:= Status.Start_Time + Periods_Num * Status.Quantum;
      -- Remove the effect of ceiling Periods_Num
      if Current > Time_Value then
         Current := Current - Status.Quantum;
      end if;
      return Current;
   end;

   protected body Ball_Status is
      procedure Set_Position(New_Position : in Coordinates_3D_T) is
      begin
         Status.Motion := Motion.Get_Fixed_Motion
           (Coordinates_3D_T'(Coordinates_T(New_Position) with 0.0));
      end Set_Position;

      procedure Set(New_Status : in Ball.Ball_Status_T) is
      begin
         Status := New_Status;
      end Set;

      procedure Set(Motion: Motion_3d_T; Possessor: Identifier_T; Free: Boolean)
      is
      begin
         Status := (Motion, Possessor, Free);
      end Set;

      procedure Set(Position: Coordinates_3D_T; Possessor: Identifier_T; Free: Boolean)
      is
      begin
         Status := (Get_Fixed_Motion(Position), Possessor, Free);
      end Set;

      function Get return Ball.Ball_Status_T is
      begin
         return Status;
      end Get;
   end Ball_Status;
end Status;
