with Ada.Strings.Unbounded; use Ada.Strings.Unbounded;

Package Utils is
   protected Logger is
      -- Append a new log to show below the field during local execution
      entry Add_Log (Text : in     String);
      -- Return the log to the printer (including the execution times
      -- recorded by the Field_Control barrier) and remove them so that
      -- they are shown only once
      entry Read_Log (Text : out Unbounded_String);
      entry Print_Log;
   private
      -- Contains the full log
      Log : Unbounded_String;
      Has_Changed    : Boolean := False;
   end Logger;
   task Printer;
end Utils;
