
package manager_gui;

import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.JLabel;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.border.EmptyBorder;
import java.awt.GridLayout;
import java.awt.FlowLayout;
import java.awt.GridBagLayout;
import java.awt.BorderLayout;
import java.awt.GridBagConstraints;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

class ConnectDialog extends JDialog {	
	
	private JComboBox mode_combo;
	private boolean connect_pressed;
	
	public ConnectDialog(final ManagerGUI manager_gui) {
		connect_pressed = false;
		setTitle("Connect");
		
		//label and combo
		JLabel mode_label = new JLabel("Select Team Manager: ");
		String[] modes = { "Local Team", "Visitor Team" };
		mode_combo = new JComboBox(modes);
		JButton connect_button = new JButton("Connect");
		connect_button.setActionCommand("connect");
        connect_button.addActionListener(manager_gui.getListener());
		JPanel grid_pane = new JPanel(new GridLayout(0, 1, 5, 5));
		grid_pane.add(mode_label);
		grid_pane.add(mode_combo);
		JPanel flow_pane = new JPanel(new FlowLayout(FlowLayout.CENTER));
		flow_pane.add(grid_pane);
		JPanel gridbag_pane = new JPanel(new GridBagLayout());
		gridbag_pane.setBorder(new EmptyBorder(0, 0, 10, 0));
		GridBagConstraints c = new GridBagConstraints();
		c.weightx = 1; c.weighty = 1;
		c.gridx = 0; c.gridy = 0;
		gridbag_pane.add(flow_pane, c);
		c.gridy = 1;
		gridbag_pane.add(connect_button, c);
		
		//layout
		setLayout(new BorderLayout());
		add(gridbag_pane);
		
		setLocationRelativeTo(manager_gui);
        setSize(300, 160);
        setResizable(false);
        setModal(true);
        addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				if (!connect_pressed)
					manager_gui.printToTextBox("You must connect before " +
											"starting to use the Manager. " +
											"Please restart this GUI.");
			}
		});
	}
	
	boolean getSelectedMode() {
		connect_pressed = true;
		if (mode_combo.getSelectedIndex() == 0)
			return true;
		else
			return false;
	}
}

