
package manager_gui;

import java.awt.Color;

class SoccerFieldStatus {
	
	private int players_number;
	private String[] players_names;
	private int[] players_numbers;
	private double[] team_x, team_y;
	private Color team_color;
	private int selected_formation;
	private boolean is_local_team;
	protected enum Axis { X, Y, Z };
	
	public SoccerFieldStatus() {
		is_local_team = true;
		selected_formation = 0;
		players_number = 17;
		team_x = new double[players_number];
		team_y = new double[players_number];
		players_names = new String[players_number];
		players_numbers = new int[players_number];
		team_color = new Color(255, 0, 0);
		for (int i = 0; i < players_number; i++) {
			players_names[i] = new String("empty-player");
			players_numbers[i] = 0;
			team_x[i] = -30;
			team_y[i] = -30;
		}
	}
	
	double getPlayerPosition(int player_index, Axis axis) {
		double out = 0;
		if (is_local_team) {
			switch (axis) {
				case X: out = team_x[player_index];
					break;
				case Y: out = team_y[player_index];
					break;
			}
		}
		else {
			switch (axis) {
				case X: out = 105 - team_x[player_index];
					break;
				case Y:
					if (team_y[player_index] < 69)
						out = 68 - team_y[player_index];
					else
						out = team_y[player_index];
					break;
			}
		}
		return out;
	}
	
	void setLocalTeam(boolean flag) {
		is_local_team = flag;
	}
	
	Color getTeamColor() {
		return team_color;
	}
	
	void setTeamColor(Color team_color) {
		this.team_color = team_color;
	}
	
	String getPlayerName(int player_index) {
		return players_names[player_index];
	}
	
	void setPlayerName(int player_index, String name) {
		players_names[player_index] = name;
	}
	
	int getPlayerNumber(int player_index) {
		return players_numbers[player_index];
	}
	
	void setPlayerNumber(int player_index, int value) {
		players_numbers[player_index] = value;
	}
	
	void setFormation(int formation) {
		selected_formation = formation;
		//players on the bench
		for (int i = 11; i < 17; i++) {
			team_x[i] = 30.0 + (i - 11.0) * 3.2;
			team_y[i] = 69.5;
		}
		switch (formation) {
		//4-4-2
		case 0:
			team_x[0] = 6;  team_y[0] = 34.5;
		
			team_x[1] = 21; team_y[1] = 14;
			team_x[2] = 21; team_y[2] = 28;
			team_x[3] = 21; team_y[3] = 43;
			team_x[4] = 21; team_y[4] = 57;
		
			team_x[5] = 38; team_y[5] = 16;
			team_x[6] = 38; team_y[6] = 29;
			team_x[7] = 38; team_y[7] = 42;
			team_x[8] = 38; team_y[8] = 55;
		
			team_x[9] = 52; team_y[9] = 30;
			team_x[10] = 52; team_y[10] = 40;
			break;
		//4-3-3
		case 1:
			team_x[0] = 6;  team_y[0] = 34.5;
		
			team_x[1] = 21; team_y[1] = 14;
			team_x[2] = 21; team_y[2] = 28;
			team_x[3] = 21; team_y[3] = 43;
			team_x[4] = 21; team_y[4] = 57;
		
			team_x[5] = 38; team_y[5] = 20;
			team_x[6] = 38; team_y[6] = 34.5;
			team_x[7] = 38; team_y[7] = 50;
		
			team_x[8] = 52; team_y[8] = 22;
			team_x[9] = 52; team_y[9] = 34.5;
			team_x[10] = 52; team_y[10] = 48;
			break;
		}
	}
	
	void setTeamBalance(int value) {
		setFormation(selected_formation);
		team_x[0] += value;
		for(int i = 1; i < 11; i++)
			team_x[i] += value * 3;
	}
	
}

