
package manager_gui;

import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.JLabel;
import javax.swing.JTable;
import javax.swing.JButton;
import javax.swing.JScrollPane;
import javax.swing.WindowConstants;
import javax.swing.border.EmptyBorder;
import java.awt.FlowLayout;
import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.awt.Dimension;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

class SubstitutionDialog extends JDialog {
	
	private ManagerGUI manager_gui;
	private JTable players_table;
	private JButton pick_button;
	private JButton apply_button;
	private JButton cancel_button;
	private boolean waiting_reply = false;
	
	public SubstitutionDialog(final ManagerGUI manager_gui) {
		this.manager_gui = manager_gui;
		this.players_table = manager_gui.getPlayersChooserTable();
		this.pick_button = manager_gui.getPickButton();
		
		manager_gui.getPlayersChooserTableModel().removeNotConvenedPlayers();
		
		JLabel label = new JLabel("Select Players");
		JPanel flow_pane2 = new JPanel(new FlowLayout(FlowLayout.CENTER,
																	20, 20));
        flow_pane2.add(label);
        
        JScrollPane scrollpane = new JScrollPane(players_table);
        
        JPanel flow_pane3 = new JPanel(new FlowLayout(FlowLayout.LEFT, 40, 20));
        JPanel grid_pane2 = new JPanel(new GridLayout(1, 0, 5, 5));
        grid_pane2.add(pick_button);
        flow_pane3.add(grid_pane2);
        
        apply_button = new JButton("Apply");
		apply_button.setActionCommand("apply-substitution");
        apply_button.addActionListener(manager_gui.getListener());
        cancel_button = new JButton("Cancel");
        cancel_button.setActionCommand("exit-substitution-dialog");
        cancel_button.addActionListener(manager_gui.getListener());
		JPanel flow_pane = new JPanel(new FlowLayout(FlowLayout.RIGHT, 60, 20));
		JPanel grid_pane = new JPanel(new GridLayout(1, 0, 5, 5));
  		grid_pane.add(cancel_button);
  		grid_pane.add(apply_button);
  		flow_pane.add(grid_pane);
  		JPanel grid_pane3 = new JPanel(new GridLayout(1, 0, 5, 5));
		grid_pane3.add(flow_pane3);
		grid_pane3.add(flow_pane);
		
		JPanel pane = new JPanel(new BorderLayout());
		pane.setBorder(new EmptyBorder(0, 20, 0, 20));
		pane.add(flow_pane2, BorderLayout.NORTH);
		pane.add(scrollpane, BorderLayout.CENTER);
        pane.add(grid_pane3, BorderLayout.SOUTH);
		
		setLayout(new BorderLayout());
		add(pane);
		
		setTitle("Substitute player");
		setLocationRelativeTo(manager_gui);
        setMinimumSize(new Dimension(650, 420));
        setResizable(true);
        setModal(true);
        setDefaultCloseOperation(WindowConstants.DO_NOTHING_ON_CLOSE);
        addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				setVisible(false);
				if (!waiting_reply)
					manager_gui.getListener().closeSubstitutionDialog();
			}
		});
	}
	
	void setEnabledButtons(boolean state) {
		apply_button.setEnabled(state);
		cancel_button.setEnabled(state);
		waiting_reply = !state;
	}

}

