
package manager_gui;

import javax.swing.table.AbstractTableModel;
import java.util.Vector;

class PlayersChooserTableModel extends AbstractTableModel {
	
	private String[] column_names = { "Name",
									"Shirt Number",
									"State",
									"Role",
									"Speed",
									"Stamina",
									"Height",
									"Jump Skill",
									"Dribble Accuracy",
									"Tackle Skill",
									"Catching Accuracy",
									"Passing Power",
									"Passing Accuracy",
									"Shooting Power",
									"Shooting Accuracy",
									"Heading Power",
									"Heading Accuracy",
									"Aggression",
									"Team Work Skill"
									};
	private Object[][] data = { };
	private int rows;
	private int cols;

	void setData(int rows, int cols, Team team_data) {
		this.rows = rows;
		this.cols = cols;
		data = new Object[rows][cols];
		Player[] first_string = team_data.getFirstStringPlayers();
		Vector<Player> substitute = team_data.getSubstitutePlayers();
		for(int i = 0; i < 11; i++) {
			setValueAt(first_string[i].getName(), i, 0);
			setValueAt(first_string[i].getShirtNumber(), i, 1);
			setValueAt(first_string[i].getStatus(), i, 2);
			setValueAt(first_string[i].getRole(), i, 3);
			setValueAt(first_string[i].getSpeed(), i, 4);
			setValueAt(first_string[i].getStamina(), i, 5);
			setValueAt(first_string[i].getHeight(), i, 6);
			setValueAt(first_string[i].getJump(), i, 7);
			setValueAt(first_string[i].getDribbling(), i, 8);
			setValueAt(first_string[i].getTackle(), i, 9);
			setValueAt(first_string[i].getCatching(), i, 10);
			setValueAt(first_string[i].getPassPower(), i, 11);
			setValueAt(first_string[i].getPassAccuracy(), i, 12);
			setValueAt(first_string[i].getShootPower(), i, 13);
			setValueAt(first_string[i].getShootAccuracy(), i, 14);
			setValueAt(first_string[i].getHeadPower(), i, 15);
			setValueAt(first_string[i].getHeadAccuracy(), i, 16);
			setValueAt(first_string[i].getAggressiveness(), i, 17);
			setValueAt(first_string[i].getTeamWorkSkill(), i, 18);
		}
		for(int i = 0; i < substitute.size(); i++) {
			setValueAt(substitute.elementAt(i).getName(), i + 11, 0);
			setValueAt(substitute.elementAt(i).getShirtNumber(), i + 11, 1);
			if (i >= 0 && i < 6)
				setValueAt(substitute.elementAt(i).getStatus(), i + 11, 2);
			else
				setValueAt(new String("not-covened"), i + 11, 2);
			setValueAt(substitute.elementAt(i).getRole(), i + 11, 3);
			setValueAt(substitute.elementAt(i).getSpeed(), i + 11, 4);
			setValueAt(substitute.elementAt(i).getStamina(), i + 11, 5);
			setValueAt(substitute.elementAt(i).getHeight(), i + 11, 6);
			setValueAt(substitute.elementAt(i).getJump(), i + 11, 7);
			setValueAt(substitute.elementAt(i).getDribbling(), i + 11, 8);
			setValueAt(substitute.elementAt(i).getTackle(), i + 11, 9);
			setValueAt(substitute.elementAt(i).getCatching(), i + 11, 10);
			setValueAt(substitute.elementAt(i).getPassPower(), i + 11, 11);
			setValueAt(substitute.elementAt(i).getPassAccuracy(), i + 11,
																		12);
			setValueAt(substitute.elementAt(i).getShootPower(), i + 11, 13);
			setValueAt(substitute.elementAt(i).getShootAccuracy(), i + 11,
																		14);
			setValueAt(substitute.elementAt(i).getHeadPower(), i + 11, 15);
			setValueAt(substitute.elementAt(i).getHeadAccuracy(), i + 11,
																		16);
			setValueAt(substitute.elementAt(i).getAggressiveness(), i + 11,
																		17);
			setValueAt(substitute.elementAt(i).getTeamWorkSkill(), i + 11,
																		18);
		}
	}
 		
	void swapPlayers(int p1, int p2) {
		if (p1 != p2) {
			//swap row
			Object[] temp_row = data[p1];
			data[p1] = data[p2];
			data[p2] = temp_row;
			//re-estabilish player state
			Object temp_cell = data[p1][2];
			data[p1][2] = data[p2][2];
			data[p2][2] = temp_cell;
			//update cells
			for (int i = 0; i < getColumnCount(); i++) {
				fireTableCellUpdated(p1, i);
				fireTableCellUpdated(p2, i);
			}
		}
	}
	
	void removeNotConvenedPlayers() {
		Object[][] temp_data = data;
		data = new Object[17][getColumnCount()];
		for (int i = 0; i < 17; i++)
			for (int j = 0; j < getColumnCount(); j++)
				setValueAt(temp_data[i][j], i, j);
	}
	
    public int getColumnCount() {
        return column_names.length;
    }

    public int getRowCount() {
        return data.length;
    }

    public String getColumnName(int col) {
        return column_names[col];
    }

    public Object getValueAt(int row, int col) {
        return data[row][col];
    }
    
    public void setValueAt(Object value, int row, int col) {
    	data[row][col] = value;
        fireTableCellUpdated(row, col);
    }
}

 
class InGameTableModel extends AbstractTableModel {
    
    private String[] column_names = { "Name",
									"Shirt Number",
									"Status",
									"Catches",
									"Goals",
									"Autogoals",
									"Shootings",
									"Passings",
									"Headings",
									"Tackles Done",
									"Tackles Suffered",
									"Fouls Done",
									"Fouls Suffered",
									"Fitness",
									"Yellow Cards",
									"Red Cards"
									};
	private Object[][] data = new Object[17][16];
	
    public int getColumnCount() {
        return column_names.length;
    }

    public int getRowCount() {
        return data.length;
    }

    public String getColumnName(int col) {
        return column_names[col];
    }

    public Object getValueAt(int row, int col) {
        return data[row][col];
    }
    
    public void setValueAt(Object value, int row, int col) {
    	data[row][col] = value;
        fireTableCellUpdated(row, col);
    }
}

