
package manager_gui;

import java.util.Vector;

class Team {
	private String id;
	private String name;
	private int def_formation;
	private int def_pressing;
	private Player[] firststring_players;
	private Vector<Player> substitute_players;
	
	public Team() {
		firststring_players = new Player[11];
		substitute_players = new Vector<Player>();
	}
	
	String getId() {
		return id;
	}
	
	void setId(String id) {
		this.id = id;
	}
	
	String getName() {
		return name;
	}
	
	void setName(String name) {
		this.name = name;
	}
	
	int getDefaultFormation() {
		return def_formation;
	}
	
	void setDefaultFormation(int def_formation) {
		this.def_formation = def_formation;
	}
	
	int getDefaultPressing() {
		return def_pressing;
	}
	
	void setDefaultPressing(int def_pressing) {
		this.def_pressing = def_pressing;
	}
	
	void addPlayer(Player p) {
		if (p.getStatus().equals("first-string"))
			firststring_players[p.getRole() - 1] = p;
		else
		if (p.getStatus().equals("substitute"))
			substitute_players.add(p); 
	}
	
	int getNumberOfPlayers() {
		return 11 + substitute_players.size();
	}
	
	Player[] getFirstStringPlayers() {
		return firststring_players;
	}
	
	Vector<Player> getSubstitutePlayers() {
		return substitute_players;
	}
	
	Vector<Player> getAllPlayers() {
		Vector<Player> players = new Vector<Player>();
		for (int i = 0; i < 11; i++)
			players.add(firststring_players[i]);
		for (int i = 0; i < substitute_players.size(); i++)
			players.add(substitute_players.elementAt(i));
		return players;
	}
}

