
package spectator_gui;

import javax.swing.JSlider;
import javax.swing.event.ChangeListener;
import javax.swing.event.ChangeEvent;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

class Listener implements ActionListener, ChangeListener {

	private SpectatorGUI spectator_gui;
	private double magnification_ratio;
	private int selected_quality;
	
	public Listener(SpectatorGUI spectator_gui) {
		this.spectator_gui = spectator_gui;
	}
	
	public void actionPerformed(ActionEvent e) {
		//players numbers check box action
		if ("players_numbers".equals(e.getActionCommand())) {
			if(spectator_gui.getSoccerField().getShowPlayersNumbers()) {
				spectator_gui.getSoccerField().setShowPlayersNumbers(false);
				spectator_gui.printToTextBox("Uniform numbers OFF.");
			}
			else {
				spectator_gui.getSoccerField().setShowPlayersNumbers(true);
				spectator_gui.printToTextBox("Uniform numbers ON.");
			}
		}
		else
		//open match statistics dialog action
		if ("stats".equals(e.getActionCommand())) {
			if (!spectator_gui.getStatsDialog().isVisible())
				spectator_gui.getStatsDialog().setVisible(true);
			spectator_gui.getStatsDialog().toFront();
		}
		else
		//render quality combo action
		if ("comboBoxChanged".equals(e.getActionCommand())) {
			int new_quality = spectator_gui.getRenderQualityCombo().
												getSelectedIndex();
			if (new_quality != selected_quality) {
				selected_quality = new_quality;
				switch (selected_quality) {
				case 0:
					spectator_gui.setRenderRefresh(30);
					spectator_gui.setChannelEventQuality(0);
					spectator_gui.printToTextBox("Render quality: High (30ms).");
					break;
				case 1:
					spectator_gui.setRenderRefresh(60);
					spectator_gui.setChannelEventQuality(1);
					spectator_gui.printToTextBox("Render quality: Medium (60ms).");
					break;
				case 2:
					spectator_gui.setRenderRefresh(90);
					spectator_gui.setChannelEventQuality(2);
					spectator_gui.printToTextBox("Render quality: Low (90ms).");
					break;
				}
			}
			else
				spectator_gui.printToTextBox("Render quality not changed.");
		}
	}
	
	//magnification slider action
	public void stateChanged(ChangeEvent e) {
		JSlider source = (JSlider)e.getSource();
		double ratio = source.getValue() / 100.0;
		spectator_gui.getSoccerField().setMagnificationRatio(ratio);
		if (!source.getValueIsAdjusting() && ratio != magnification_ratio) {
			magnification_ratio = ratio;
			spectator_gui.printToTextBox("Players magnification has been set " +
											  "to: " + source.getValue() + "%.");
		}
	}
	 
}

