
package spectator_gui;

import javax.swing.SwingWorker;

class Renderer extends SwingWorker<Void, Void> {
	
	private SpectatorGUI spectator_gui;
	private boolean exit;
	private int ms_cycle;
	
	public Renderer(SpectatorGUI spectator_gui) {
		this.spectator_gui = spectator_gui;
		exit = false;
		ms_cycle = 30;
		System.out.println("[renderer]* Renderer is ready");
	}
	 
	protected Void doInBackground() {
		//started by the first callback of FotogramSubscriber
		System.out.println("[renderer]* Renderer started");
		SoccerFieldPane soccer_field = spectator_gui.getSoccerField();
		while (!exit) {
	 		soccer_field.repaint();
	 		try {
				Thread.sleep(ms_cycle);
			}
			catch (InterruptedException ex) {
				exit = true;
			}
		}
		System.out.println("[renderer]* Renderer terminates");
		return null;
	}
	
	void terminateRender() {
		exit = true;
	}
	
	void setRefresh(int milliseconds) {
		ms_cycle = milliseconds;
	}
	 
}

