
package spectator_gui;

class SoccerFieldStatus {

	private double soccer_ball_pos_x, soccer_ball_pos_y, soccer_ball_pos_z;
	private double[] team1_x, team1_y;
	private int[] team1_numbers;
	private double[] team2_x, team2_y;
	private int[] team2_numbers;
	protected enum Axis { X, Y, Z };
	
	public SoccerFieldStatus() {
		team1_numbers = new int[11];
		team1_x = new double[11];
		team1_y = new double[11];
		team2_numbers = new int[11];
		team2_x = new double[11];
		team2_y = new double[11];
		
		soccer_ball_pos_x = -100.0;
		soccer_ball_pos_y = -100.0;
		soccer_ball_pos_z = 0.0;
		for(int i = 0; i < 11; i++) {
			team1_numbers[i] = i + 1;
			team1_x[i] = -100.0;
			team1_y[i] = -100.0;
			team2_numbers[i] = i + 1;
			team2_x[i] = -100.0;
			team2_y[i] = -100.0;
		}
	}
	
	double getBallPosition(Axis axis) {
		double out = 0.0;
		switch (axis) {
			case X: out = soccer_ball_pos_x;
				break;
			case Y: out = soccer_ball_pos_y;
				break;
			case Z: out = soccer_ball_pos_z;
				break;
		}
		return out;
	}
	
	void setBallPosition(Axis axis, double value) {
		switch (axis) {
			case X: soccer_ball_pos_x = value;
				break;
			case Y: soccer_ball_pos_y = value;
				break;
			case Z: soccer_ball_pos_z = value;
				break;
		}
	}
	
	double getPlayerPosition(String team, int player_index, Axis axis) {
		double out = 0;
		if (team == "team1") {
			switch (axis) {
				case X: out = team1_x[player_index];
					break;
				case Y: out = team1_y[player_index];
					break;
			}
		}
		else
		if (team == "team2") {
			switch (axis) {
				case X: out = team2_x[player_index];
					break;
				case Y: out = team2_y[player_index];
					break;
			}
		}
		return out;
	}
	
	void setPlayerPosition(String team, int player_index,
										Axis axis, double value) {
		if (team == "team1") {
			switch (axis) {
				case X: team1_x[player_index] = value;
					break;
				case Y: team1_y[player_index] = value;
					break;
			}
		}
		else
		if (team == "team2") {
			switch (axis) {
				case X: team2_x[player_index] = value;
					break;
				case Y: team2_y[player_index] = value;
					break;
			}
		}
	}
	
	int getPlayerNumber(String team, int player_index) {
		int out = 0;
		if (team == "team1")
			out = team1_numbers[player_index];
		else
		if (team == "team2")
			out = team2_numbers[player_index];
		return out;
	}
	
	void setPlayerNumber(String team, int player_index, int value) {
		if (team == "team1")
			team1_numbers[player_index] = value;
		else
		if (team == "team2")
			team2_numbers[player_index] = value;
	}
	
}

