
package spectator_gui;

import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.JLabel;
import javax.swing.SwingConstants;
import javax.swing.border.EmptyBorder;
import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Color;

class StatisticsDialog extends JDialog {
	
	private JLabel score, score_locals, score_visitors;
	private JLabel empty_label, empty_label_locals, empty_label_visitors;
	private JLabel shootings, shootings_locals, shootings_visitors;
	private JLabel catches, catches_locals, catches_visitors;
	private JLabel corner_kicks, corner_kicks_locals, corner_kicks_visitors;
	private JLabel fouls_done, fouls_done_locals, fouls_done_visitors;
	private JLabel fouls_suffered, fouls_suffered_locals, fouls_suffered_visitors;
	private JLabel yellow_cards, yellow_cards_locals, yellow_cards_visitors;
	private JLabel red_cards, red_cards_locals, red_cards_visitors;
	private JLabel free_kicks, free_kicks_locals, free_kicks_visitors;
	private JLabel penalty_kicks, penalty_kicks_locals, penalty_kicks_visitors;
	private JLabel autogoals, autogoals_locals, autogoals_visitors;
	private JLabel passings, passings_locals, passings_visitors;
	private JLabel tackles_done, tackles_done_locals, tackles_done_visitors;
	private JLabel tackles_suffered, tackles_suffered_locals,
													tackles_suffered_visitors;
	private JLabel throw_ins, throw_ins_locals, throw_ins_visitors;
	private JLabel headings, headings_locals, headings_visitors;
	private JLabel goal_kicks, goal_kicks_locals, goal_kicks_visitors;
	private JLabel kick_offs, kick_offs_locals, kick_offs_visitors;
	
	public StatisticsDialog(SpectatorGUI spectator_gui) {
		setTitle("Match Statistics");
		
		score = new JLabel("Initializing...", SwingConstants.CENTER);
		score.setFont(new Font("Arial", Font.BOLD, 16));
		empty_label = new JLabel(" ", SwingConstants.CENTER);
		shootings = new JLabel("Shootings", SwingConstants.CENTER);
		catches = new JLabel("Catches", SwingConstants.CENTER);
		corner_kicks = new JLabel("Corner Kicks", SwingConstants.CENTER);
		fouls_done = new JLabel("Fouls Done", SwingConstants.CENTER);
		fouls_suffered = new JLabel("Fouls Suffered", SwingConstants.CENTER);
		yellow_cards = new JLabel("Yellow Cards", SwingConstants.CENTER);
		red_cards = new JLabel("Red Cards", SwingConstants.CENTER);
		free_kicks = new JLabel("Free Kicks", SwingConstants.CENTER);
		penalty_kicks = new JLabel("Penalty Kicks", SwingConstants.CENTER);
		autogoals = new JLabel("Autogoals", SwingConstants.CENTER);
		passings = new JLabel("Passings", SwingConstants.CENTER);
		tackles_done = new JLabel("Tackles Done", SwingConstants.CENTER);
		tackles_suffered = new JLabel("Tackles Suffered", SwingConstants.CENTER);
		throw_ins = new JLabel("Throw Ins", SwingConstants.CENTER);
		headings = new JLabel("Headings", SwingConstants.CENTER);
		goal_kicks = new JLabel("Goal Kicks", SwingConstants.CENTER);
		kick_offs = new JLabel("Kick-offs", SwingConstants.CENTER);
		
		score_locals = new JLabel("", SwingConstants.CENTER);
		score_locals.setFont(new Font("Arial", Font.BOLD, 16));
		score_locals.setForeground(Color.red);
		empty_label_locals = new JLabel("", SwingConstants.CENTER);
		empty_label_locals.setForeground(Color.red);
		shootings_locals = new JLabel("", SwingConstants.CENTER);
		shootings_locals.setForeground(Color.red);
		catches_locals = new JLabel("", SwingConstants.CENTER);
		catches_locals.setForeground(Color.red);
		corner_kicks_locals = new JLabel("", SwingConstants.CENTER);
		corner_kicks_locals.setForeground(Color.red);
		fouls_done_locals = new JLabel("", SwingConstants.CENTER);
		fouls_done_locals.setForeground(Color.red);
		fouls_suffered_locals = new JLabel("", SwingConstants.CENTER);
		fouls_suffered_locals.setForeground(Color.red);
		yellow_cards_locals = new JLabel("", SwingConstants.CENTER);
		yellow_cards_locals.setForeground(Color.red);
		red_cards_locals = new JLabel("", SwingConstants.CENTER);
		red_cards_locals.setForeground(Color.red);
		free_kicks_locals = new JLabel("", SwingConstants.CENTER);
		free_kicks_locals.setForeground(Color.red);
		penalty_kicks_locals = new JLabel("", SwingConstants.CENTER);
		penalty_kicks_locals.setForeground(Color.red);
		autogoals_locals = new JLabel("", SwingConstants.CENTER);
		autogoals_locals.setForeground(Color.red);
		passings_locals = new JLabel("", SwingConstants.CENTER);
		passings_locals.setForeground(Color.red);
		tackles_done_locals = new JLabel("", SwingConstants.CENTER);
		tackles_done_locals.setForeground(Color.red);
		tackles_suffered_locals = new JLabel("", SwingConstants.CENTER);
		tackles_suffered_locals.setForeground(Color.red);
		throw_ins_locals = new JLabel("", SwingConstants.CENTER);
		throw_ins_locals.setForeground(Color.red);
		headings_locals = new JLabel("", SwingConstants.CENTER);
		headings_locals.setForeground(Color.red);
		goal_kicks_locals = new JLabel("", SwingConstants.CENTER);
		goal_kicks_locals.setForeground(Color.red);
		kick_offs_locals = new JLabel("", SwingConstants.CENTER);
		kick_offs_locals.setForeground(Color.red);
		
		score_visitors = new JLabel("", SwingConstants.CENTER);
		score_visitors.setFont(new Font("Arial", Font.BOLD, 16));
		score_visitors.setForeground(Color.blue);
		empty_label_visitors = new JLabel("", SwingConstants.CENTER);
		empty_label_visitors.setForeground(Color.blue);
		shootings_visitors = new JLabel("", SwingConstants.CENTER);
		shootings_visitors.setForeground(Color.blue);
		catches_visitors = new JLabel("", SwingConstants.CENTER);
		catches_visitors.setForeground(Color.blue);
		corner_kicks_visitors = new JLabel("", SwingConstants.CENTER);
		corner_kicks_visitors.setForeground(Color.blue);
		fouls_done_visitors = new JLabel("", SwingConstants.CENTER);
		fouls_done_visitors.setForeground(Color.blue);
		fouls_suffered_visitors = new JLabel("", SwingConstants.CENTER);
		fouls_suffered_visitors.setForeground(Color.blue);
		yellow_cards_visitors = new JLabel("", SwingConstants.CENTER);
		yellow_cards_visitors.setForeground(Color.blue);
		red_cards_visitors = new JLabel("", SwingConstants.CENTER);
		red_cards_visitors.setForeground(Color.blue);
		free_kicks_visitors = new JLabel("", SwingConstants.CENTER);
		free_kicks_visitors.setForeground(Color.blue);
		penalty_kicks_visitors = new JLabel("", SwingConstants.CENTER);
		penalty_kicks_visitors.setForeground(Color.blue);
		autogoals_visitors = new JLabel("", SwingConstants.CENTER);
		autogoals_visitors.setForeground(Color.blue);
		passings_visitors = new JLabel("", SwingConstants.CENTER);
		passings_visitors.setForeground(Color.blue);
		tackles_done_visitors = new JLabel("", SwingConstants.CENTER);
		tackles_done_visitors.setForeground(Color.blue);
		tackles_suffered_visitors = new JLabel("", SwingConstants.CENTER);
		tackles_suffered_visitors.setForeground(Color.blue);
		throw_ins_visitors = new JLabel("", SwingConstants.CENTER);
		throw_ins_visitors.setForeground(Color.blue);
		headings_visitors = new JLabel("", SwingConstants.CENTER);
		headings_visitors.setForeground(Color.blue);
		goal_kicks_visitors = new JLabel("", SwingConstants.CENTER);
		goal_kicks_visitors.setForeground(Color.blue);
		kick_offs_visitors = new JLabel("", SwingConstants.CENTER);
		kick_offs_visitors.setForeground(Color.blue);
		
		//add components		
		JPanel grid_pane_labels = new JPanel(new GridLayout(20, 1, 4, 4));
		JPanel grid_pane_locals = new JPanel(new GridLayout(20, 1, 4, 4));
		JPanel grid_pane_visitors = new JPanel(new GridLayout(20, 1, 4, 4));
		grid_pane_labels.setBorder(new EmptyBorder(20, 2, 10, 2));
		grid_pane_locals.setBorder(new EmptyBorder(20, 40, 10, 20));
		grid_pane_visitors.setBorder(new EmptyBorder(20, 20, 10, 40));
		
		grid_pane_labels.add(score);
		grid_pane_labels.add(empty_label);
		grid_pane_labels.add(shootings);
		grid_pane_labels.add(catches);
		grid_pane_labels.add(corner_kicks);
		grid_pane_labels.add(fouls_done);
		grid_pane_labels.add(fouls_suffered);
		grid_pane_labels.add(yellow_cards);
		grid_pane_labels.add(red_cards);
		grid_pane_labels.add(free_kicks);
		grid_pane_labels.add(penalty_kicks);
		grid_pane_labels.add(autogoals);
		grid_pane_labels.add(passings);
		grid_pane_labels.add(tackles_done);
		grid_pane_labels.add(tackles_suffered);
		grid_pane_labels.add(throw_ins);
		grid_pane_labels.add(headings);
		grid_pane_labels.add(goal_kicks);
		grid_pane_labels.add(kick_offs);
		
		grid_pane_locals.add(score_locals);
		grid_pane_locals.add(empty_label_locals);
		grid_pane_locals.add(shootings_locals);
		grid_pane_locals.add(catches_locals);
		grid_pane_locals.add(corner_kicks_locals);
		grid_pane_locals.add(fouls_done_locals);
		grid_pane_locals.add(fouls_suffered_locals);
		grid_pane_locals.add(yellow_cards_locals);
		grid_pane_locals.add(red_cards_locals);
		grid_pane_locals.add(free_kicks_locals);
		grid_pane_locals.add(penalty_kicks_locals);
		grid_pane_locals.add(autogoals_locals);
		grid_pane_locals.add(passings_locals);
		grid_pane_locals.add(tackles_done_locals);
		grid_pane_locals.add(tackles_suffered_locals);
		grid_pane_locals.add(throw_ins_locals);
		grid_pane_locals.add(headings_locals);
		grid_pane_locals.add(goal_kicks_locals);
		grid_pane_locals.add(kick_offs_locals);
		
		grid_pane_visitors.add(score_visitors);
		grid_pane_visitors.add(empty_label_visitors);
		grid_pane_visitors.add(shootings_visitors);
		grid_pane_visitors.add(catches_visitors);
		grid_pane_visitors.add(corner_kicks_visitors);
		grid_pane_visitors.add(fouls_done_visitors);
		grid_pane_visitors.add(fouls_suffered_visitors);
		grid_pane_visitors.add(yellow_cards_visitors);
		grid_pane_visitors.add(red_cards_visitors);
		grid_pane_visitors.add(free_kicks_visitors);
		grid_pane_visitors.add(penalty_kicks_visitors);
		grid_pane_visitors.add(autogoals_visitors);
		grid_pane_visitors.add(passings_visitors);
		grid_pane_visitors.add(tackles_done_visitors);
		grid_pane_visitors.add(tackles_suffered_visitors);
		grid_pane_visitors.add(throw_ins_visitors);
		grid_pane_visitors.add(headings_visitors);
		grid_pane_visitors.add(goal_kicks_visitors);
		grid_pane_visitors.add(kick_offs_visitors);
		
		setLayout(new BorderLayout());
		add(grid_pane_locals, BorderLayout.WEST);
		add(grid_pane_labels, BorderLayout.CENTER);
		add(grid_pane_visitors, BorderLayout.EAST);
	
		setLocationRelativeTo(spectator_gui);
        setMinimumSize(new Dimension(280, 435));
        setMaximumSize(new Dimension(300, 500));
	}
	
	void updateStats(String team_locals, int score_locals,
								int shootings_locals, int catches_locals,
								int corner_kicks_locals, int fouls_done_locals,
								int fouls_suff_locals, int yellow_cards_locals,
								int red_cards_locals, int free_kicks_locals,
								int penalty_kicks_locals, int autogoals_locals,
								int passings_locals, int tackles_done_locals,
								int tackles_suff_locals, int throw_ins_locals,
								int headings_locals, int goal_kicks_locals,
								int kick_offs_locals, String team_visitors,
								int score_visitors, int shootings_visitors,
								int catches_visitors, int corner_kicks_visitors,
								int fouls_done_visitors, int fouls_suff_visitors,
								int yellow_cards_visitors, int red_cards_visitors,
								int free_kicks_visitors, int penalty_kicks_visitors,
								int autogoals_visitors, int passings_visitors,
								int tackles_done_visitors, int tackles_suff_visitors,
								int throw_ins_visitors, int headings_visitors,
								int goal_kicks_visitors, int kick_offs_visitors) {
		//updates score label
		score.setText("<html><font color=\"red\">" + team_locals +
						"</font> - <font color=\"blue\">" + team_visitors +
						"</font></html>");
		//updates locals labels
		this.score_locals.setText(Integer.toString(score_locals));
		this.shootings_locals.setText(Integer.toString(shootings_locals));
		this.catches_locals.setText(Integer.toString(catches_locals));
		this.corner_kicks_locals.setText(Integer.toString(corner_kicks_locals));
		this.fouls_done_locals.setText(Integer.toString(fouls_done_locals));
		this.fouls_suffered_locals.setText(Integer.toString(fouls_suff_locals));
		this.yellow_cards_locals.setText(Integer.toString(yellow_cards_locals));
		this.red_cards_locals.setText(Integer.toString(red_cards_locals));
		this.free_kicks_locals.setText(Integer.toString(free_kicks_locals));
		this.penalty_kicks_locals.setText(Integer.toString(penalty_kicks_locals));
		this.autogoals_locals.setText(Integer.toString(autogoals_locals));
		this.passings_locals.setText(Integer.toString(passings_locals));
		this.tackles_done_locals.setText(Integer.toString(tackles_done_locals));
		this.tackles_suffered_locals.setText(Integer.toString(tackles_suff_locals));
		this.throw_ins_locals.setText(Integer.toString(throw_ins_locals));
		this.headings_locals.setText(Integer.toString(headings_locals));
		this.goal_kicks_locals.setText(Integer.toString(goal_kicks_locals));
		this.kick_offs_locals.setText(Integer.toString(kick_offs_locals));
		//updates visitors labels
		this.score_visitors.setText(Integer.toString(score_visitors));
		this.shootings_visitors.setText(Integer.toString(shootings_visitors));
		this.catches_visitors.setText(Integer.toString(catches_visitors));
		this.corner_kicks_visitors.setText(Integer.toString(corner_kicks_visitors));
		this.fouls_done_visitors.setText(Integer.toString(fouls_done_visitors));
		this.fouls_suffered_visitors.setText(Integer.toString(fouls_suff_visitors));
		this.yellow_cards_visitors.setText(Integer.toString(yellow_cards_visitors));
		this.red_cards_visitors.setText(Integer.toString(red_cards_visitors));
		this.free_kicks_visitors.setText(Integer.toString(free_kicks_visitors));
		this.penalty_kicks_visitors.setText(Integer.toString(penalty_kicks_visitors));
		this.autogoals_visitors.setText(Integer.toString(autogoals_visitors));
		this.passings_visitors.setText(Integer.toString(passings_visitors));
		this.tackles_done_visitors.setText(Integer.toString(tackles_done_visitors));
		this.tackles_suffered_visitors.setText(Integer.toString(tackles_suff_visitors));
		this.throw_ins_visitors.setText(Integer.toString(throw_ins_visitors));
		this.headings_visitors.setText(Integer.toString(headings_visitors));
		this.goal_kicks_visitors.setText(Integer.toString(goal_kicks_visitors));
		this.kick_offs_visitors.setText(Integer.toString(kick_offs_visitors));
	}

}

